<template>
  <q-page class="flex-center">
    <q-table
      :rows-per-page-options="[15, 25, 50]"
      :data="data"
      :columns="columns"
      separator="cell"
      :loading="loading"
      :pagination.sync="pagination"
      @request="onRequest"
      row-key="id"
    >
      <template slot="top" slot-scope="props">
        <q-btn
          push
          rounded
          color="primary"
          icon="add"
          @click="add()"
          v-show="permissions.includes('add_message')"
          >Add Messages
        </q-btn>
        <div class="col" />
      </template>
      <q-tr slot="body" slot-scope="props" :props="props">
        <q-td
          key="No"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
          >{{ props.row.No }}</q-td
        >
        <q-td
          key="message"
          :props="props"
          :style="{ width: '500px', whiteSpace: 'normal' }"
          >{{ props.row.message }}</q-td
        >
        <q-td
          key="status"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
        >
          <q-toggle
            v-model="props.row.status"
            @input="ChangeStatus(props.row)"
            :false-value="0"
            :true-value="1"
            v-show="permissions.includes('change_message')"
          ></q-toggle>
          <!-- <q-btn
            size="sm"
            :color="btn[props.row.status].color"
            :label="btn[props.row.status].label"
            class="q-mr-sm"
            @click="ChangeStatus(props.row)"
            v-show="permissions.includes('change_message')"
          /> -->
          <div v-show="!permissions.includes('change_message')">
            {{ props.row.status == 1 ? "True" : "False" }}
          </div>
        </q-td>
        <q-td
          key="action"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
        >
          <div class="row items-center justify-center no-wrap">
            <q-btn
              size="sm"
              round
              rounded
              color="secondary"
              icon="edit"
              @click="load(props.row)"
              class="q-mr-xs"
              v-show="permissions.includes('change_message')"
            />
            <q-btn
              size="sm"
              round
              rounded
              color="negative"
              icon="delete"
              @click="remove(props.row)"
              class="q-mr-xs"
              v-show="permissions.includes('delete_message')"
            />
          </div>
        </q-td>
      </q-tr>
      <template v-slot:top-row>
        <q-tr>
          <q-td></q-td>
          <q-td>
            <q-input
              dense
              debounce="300"
              outlined
              v-model="filter.message"
              label="Filter Message"
              @input="getdata"
            ></q-input>
          </q-td>
          <q-td>
            <q-select
              dense
              debounce="300"
              outlined
              label="Filter Status"
              v-model="filter.status"
              :options="options"
              option-value="value"
              option-label="label"
              option-disable="inactive"
              emit-value
              map-options
              @input="getdata"
            />
          </q-td>
          <q-td></q-td>
        </q-tr>
      </template>
    </q-table>
    <!-- add -->
    <q-dialog
      v-model="modal_add"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form"
            ref="form"
            :rules="rules"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Message" prop="message">
              <el-input v-model="form.message" autocomplete="off"></el-input>
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions
          align="right"
          class="bg-primary text-white"
          v-show="permissions.includes('add_message')"
        >
          <q-btn push rounded color="primary" @click="insert()">Submit</q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- update -->
    <q-dialog
      v-model="modal_edit"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_edit"
            ref="form_edit"
            :rules="rules"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Message" prop="message">
              <el-input
                v-model="form_edit.message"
                autocomplete="off"
              ></el-input>
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions
          align="right"
          class="bg-primary text-white"
          v-show="permissions.includes('change_message')"
        >
          <q-btn push rounded color="primary" @click="Update()">Submit</q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
export default {
  name: "Messages",
  data() {
    return {
      data: [],
      search: "",
      columns: [
        {
          name: "No",
          label: "No",
          field: "No",
          align: "left",
          stortable: true
        },
        {
          name: "message",
          label: "Message",
          field: "message",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "status",
          label: "Status",
          field: "status",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "action",
          label: "Action",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      filter: {},
      separator: "horizontal",
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 10,
        rowsNumber: 10
      },
      modal_edit: false,
      modal_add: false,
      form: { message: "" },
      form_edit: {},
      rules: {
        message: [
          { required: true, message: "Please input messages", trigger: "blur" }
        ]
        // status: [
        //   { required: true, message: "Please Select Status", trigger: "change" }
        // ]
      },
      options: [
        { value: 1, label: "Enable" },
        { value: 0, label: "Disable" }
      ],
      btn: [
        { label: "Disable", color: "red" },
        { label: "Enable", color: "primary" }
      ],
      loading: false,
      permissions:
        this.$q.sessionStorage.getItem("permissions")["message"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["message"]
          : []
    };
  },

  async created() {
    await this.getdata();
  },

  methods: {
    async onRequest(props) {
      try {
        this.loading = true;
        const { page, rowsPerPage, sortBy, descending } = props.pagination;
        this.filter.page_limit = rowsPerPage;
        this.filter.page = page;
        if (this.filter.message == "") {
          delete this.filter.message;
        }
        let result = await this.$services.message.read(this.filter);
        this.pagination.rowsNumber = result.total;
        const fetchCount =
          rowsPerPage === 0 ? this.pagination.rowsNumber : rowsPerPage;
        const startRow = (page - 1) * rowsPerPage;
        this.data = result.results;
        this.$services.updateindex(this.data);
        this.pagination.page = page;
        this.pagination.rowsPerPage = rowsPerPage;
        this.pagination.sortBy = sortBy;
        this.pagination.descending = descending;
        this.loading = false;
      } catch (e) {
        this.$services.error(e.response, this.$router);
      }
    },

    async getdata() {
      this.onRequest({
        pagination: this.pagination
      });
    },

    add() {
      this.modal_add = true;
      this.form = { message: "" };
    },

    async insert() {
      let ctx = this;
      this.$refs.form.validate(valid => {
        if (valid) {
          this.$services.message
            .add(this.form)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_add = false;
              ctx.$services.success("Save Message Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        }
      });
    },

    load(row) {
      this.form_edit = row;
      this.modal_edit = true;
    },

    async Update() {
      let ctx = this;
      this.$refs.form_edit.validate(valid => {
        if (valid) {
          this.$services.message
            .update(this.form_edit, this.form_edit.id)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_edit = false;
              ctx.$services.success("Update Message Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        }
      });
    },

    async remove(row) {
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want to Message ${row.message} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.message
            .remove(row.id)
            .then(function(e) {
              ctx.getdata();
              ctx.$services.success(
                "Delete Message " + row.message + " Success"
              );
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          // console.log(">>>> Cancel");
        });
    },

    ChangeStatus(row) {
      const prev = row.status == 0 ? 1 : 0;
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Status to Message ${row.message} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.message
            .update(row, row.id)
            .then(function(data) {
              ctx.getdata();
              ctx.$services.success("Update Message Success");
            })
            .catch(function(e) {
              row.status = prev;
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          row.status = prev;
          // console.log(">>>> Cancel");
        });
    }
  }
};
</script>

<style lang="stylus"></style>
